Subject: [tsvwg] SCTP ABC

From: Timo Völker <[email-masked]>
Date: Wed, 23 Jun 2021 15:01:43 +0000

Hi,

SCTP (RFC4960) limits the increase of its cwnd in slow start to one PMTU (or PMDCS as named in the rfc4960-bis document) as stated in Section 7.2.1. This means the cwnd may be increased less when the receiver sends an ack on every second packet compared to on every packet.

---
Ex:
1. A sender in slow start with PMTU=1200 sends two packets with 1000 byte of data each.

> DATA(len=1000, tsn=1)
> DATA(len=1000, tsn=2)

2a. In case the receiver sends an ack on every packet, the sender receives two acks.

< ACK(cum_tsn=1)
--> cwnd += 1000
< ACK(cum_tsn=2)
--> cwnd += 1000

resulting in a cwnd increased by 2000 byte.

2b. In case the receiver sends an ack on every second packet, the sender receives one ack for both packets.

< ACK(cum_tsn=2)
--> cwnd += 1200

resulting in a cwnd increased by only 1200 byte due to the PMTU limit.
---

TCP's Appropriate Byte Counting (ABC) specified in RFC3465 addresses that with the parameter L set to 2*SMSS.

Adding a note for that in rfc4960-bis would help, I think.

Timo

---

From: "Gorry (erg)" <[email-masked]>
Date: Thu, 24 Jun 2021 08:45:28 +0100

See below:

> On 23 Jun 2021, at 16:02, Timo Völker <[email-masked]> wrote:
> 
> Hi,
> 

What do others think?

Are the SCTP implementors happy with this proposal?

Gorry

---

From: Michael Tuexen <[email-masked]>
Date: Thu, 24 Jun 2021 09:53:51 +0200

> On 24. Jun 2021, at 09:45, Gorry (erg) <[email-masked]> wrote:
> 
> See below:
> 
I would support integrating the ABC idea. This has been implemented in the FreeBSD kernel stack
and the userland stack for a long time.

Best regards
Michael